Bug 240373 - Review Request: qtiplot - Data Analysis and Scientific Plotting
Review Request: qtiplot - Data Analysis and Scientific Plotting
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mamoru TASAKA
Fedora Package Reviews List
:
Depends On: PyQt4 214193 240180 240287 240308 344641 344661 344681
Blocks: 243501
  Show dependency treegraph
 
Reported: 2007-05-16 16:04 EDT by Frank Büttner
Modified: 2008-01-19 14:18 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-10-21 19:44:56 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mtasaka: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)
rpmlint result for qtiplot 0.9-5 (17.91 KB, text/plain)
2007-10-07 03:45 EDT, Mamoru TASAKA
no flags Details

  None (edit)
Description Frank Büttner 2007-05-16 16:04:23 EDT
Spec URL: http://downloads.sourceforge.net/qsmartcard/qtiplot.spec?use_mirror=dfn
SRPM URL: http://downloads.sourceforge.net/qsmartcard/qtiplot-0.9_rc1-1FC5.src.rpm?use_mirror=dfn
Description:
Scientists often need to use data analysis and plotting software.
For Windows systems there is a well known and widely used software
called Origin, which is not free, of course. The purpose of this
project is to develop a free (open source), platform independent
alternative to Origin.
Comment 1 Frank Büttner 2007-05-21 10:32:11 EDT
Move the big docu to an noarch file, so save much space on the repo mirrors.
new files:
SPEC: http://downloads.sourceforge.net/qsmartcard/qtiplot.spec?use_mirror=osdn
SRPM:
http://downloads.sourceforge.net/qsmartcard/qtiplot-0.9_rc1-2.fc6.src.rpm?use_mirror=osdn
Comment 2 Jason Tibbitts 2007-06-03 01:43:54 EDT
It is simply not possible to split the package in the way you are attempting. 
If you want the manual in a separate noarch package, you need to submit it
separately.  (But only do so if there's a separate upstream documentation
tarball, which there seems to be in this case.)
Comment 3 Frank Büttner 2007-06-06 04:22:12 EDT
But this seems not to be clean, because when you look at the .spec file for the
kernel, that this will be used for both. The platform depend and independent part.
The RPM will be only compiled twice. On time with the --tagted noarch parameter
on  time with --target XXXX XXX= binary target. The trick is only to tell the
the build system of Fedora. But it must be possible. The kernel is the best
evidence.
Comment 4 Mamoru TASAKA 2007-06-06 09:28:08 EDT
(In reply to comment #3)
> But this seems not to be clean, because when you look at the .
> spec file for the
> kernel, that this will be used for both. 
> The platform depend and independent part.
> The RPM will be only compiled twice. On time with the --tagted noarch parameter
> on  time with --target XXXX XXX= binary target. The trick is only to tell the
> the build system of Fedora. But it must be possible. The kernel is the best
> evidence.

Well, while kernel.spec correctly plays the trick to
rebuild kernel srpm on several arch + noarch using ONE srpm on
koji buildsys, your spec file is actually wrong....
because unless you specify in the correct way that you want to
have this package rebuilt on both i386 and noarch (for example),
buildsys regards this package as to be built on i386 (x86_64,...) and
not on noarch (i.e. if you rebuild this srpm on koji, the build
target is always not-noarch).

And, 

(In reply to comment #2)
> (But only do so if there's a separate upstream documentation
> tarball, which there seems to be in this case.)
Actually as this package has seperate documentation tarball with
no version relation wich src tarball, you must sumbit a seperate
review request.
Otherwise each time you rebuild the srpm, the EVR of noarch part
rpm will be bumped unnecessarily (for kernel, this must be necessary).


Comment 5 Jason Tibbitts 2007-06-07 14:47:21 EDT
The bottom line is that the kernel gets to be special and has hooks and hacks in
various places to make it work.  Those simply will not be extended to this package.

The best thing to do is to remove the documentation from this package and submit
it separately.
Comment 7 Mamoru TASAKA 2007-09-30 03:56:11 EDT
Just a initial comment (I have not rebuilt your srpm)

* First of all,
  now 0.9 seems released already so please update this.

* For license:
  Current valid list for Fedora in written on
  http://fedoraproject.org/wiki/Licensing
  Also please refer to
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines
  - In short
    For GPL, now Fedora requests that you must specify the version
    (either GPL+, GPLv2, GPLv2+, GPLv3, GPLv3+ or "with exceptions")

* Timestamp
  - For "cp" or "install", please use "-p" option to keep timestamp.

* symlink library
  - Please check is symlinks *.so (not *.so.X or *.so.X.Y) are
    really needed.

* Directory ownership
  - The directory %{_docdir}/%{name}/ itself should also be owned
    by this package.
  - And usually this should be %{_docdir}/%{name}-%{version}.
    But when you want to change documents directory, you may also
    have to modify source codes, too
Comment 8 Frank Büttner 2007-09-30 05:45:49 EDT
So save space on the repo server I have split the doc to an separate package.
So here the new spec file:
http://downloads.sourceforge.net/qsmartcard/qtiplot.spec?use_mirror=osdn
Comment 9 Mamoru TASAKA 2007-09-30 09:18:53 EDT
Just a note:

Currently PyQt review request (bug 190189) is now blocked
by sip bug (bug 289321)
Comment 10 Frank Büttner 2007-09-30 09:53:03 EDT
I have read this for some weeks ago. This is the reason on the slow develop of
this package.
Comment 11 Mamoru TASAKA 2007-10-04 12:43:15 EDT
Frank, I approved PyQt4 review request (bug 190189) and Rex requested
for CVS branch, so PyQt4 will be imported soon.

After that would you recheck your spec/srpm file and post on this bug
if your spec/srpm still works (for you)? (by the way I would appreciate 
it very much if you create srpm, too).
Comment 12 Mamoru TASAKA 2007-10-04 12:44:59 EDT
One note:

Currently PyQt4 has "Exclude: ppc64".
Comment 13 Rex Dieter 2007-10-04 13:32:05 EDT
fyi, I think I just fixed that too (in qt4, see bug #246324)
Comment 14 Frank Büttner 2007-10-06 12:06:54 EDT
So now the first version, that can be build, via mock without help repos.
SRPM:
http://downloads.sourceforge.net/qsmartcard/qtiplot-0.9-5.fc8.src.rpm?use_mirror=osdn
SPEC: http://downloads.sourceforge.net/qsmartcard/qtiplot.spec?use_mirror=osdn
Comment 15 Mamoru TASAKA 2007-10-07 03:45:41 EDT
Created attachment 218591 [details]
rpmlint result for qtiplot 0.9-5

!. First for rpmlint issue:
   Please check your rpms by rpmlint for review.
   You can check many items by using rpmlint for 
   - binary rpms
   - srpms
   - and for installed rpms.
   rpmlint results are attached.

* devel-file-in-non-devel-package
  - Please check if symlinks %{_libdir}/lib*.so (not lib*.so.*) are
    really needed.

* no-cleaning-of-buildroot %install
  - %install section must clean up %buildroot first.

* mixed-use-of-spaces-and-tabs
  - Please check what this means by 
    "$ rpmlint -I mixed-use-of-spaces-and-tabs".

* wrong-script-end-of-line-encoding
  - This means that this file has windows-like end-of-line encoding.
    Fix this by "sed -i -e 's|\r||' <file>" or dos2unix.

* spurious-executable-perm
  - Fix the permission (usually should be 0644)

* undefined-non-weak-symbol
  - /usr/lib/libfitRational1.so.1.0.0 has undefined non-weak symbol.
-----------------------------------------------------
$ ldd -r /usr/lib/libfitRational1.so.1.0.0 > /dev/null
undefined symbol: gsl_matrix_set	(/usr/lib/libfitRational1.so.1.0.0)
undefined symbol: gsl_vector_set	(/usr/lib/libfitRational1.so.1.0.0)
undefined symbol: gsl_vector_get	(/usr/lib/libfitRational1.so.1.0.0)
-----------------------------------------------------
    This can be ignored because this package does not provide
    -devel subpackage, however for this package this can be
    fixed by linking against libgsl.so.

B. The rest issues:
* Redundant BuildRequires
  - Remove redundant BuildRequires and reduce them.
    For example, PyQt4-devel Requires qt4-devel and sip-devel, so
    "BuildRequires: qt4-devel sip-devel" is not needed.
    (Please also check the rest BuildRequires!)

  - By the way I prefer to write one BuildRequires per one line
    because it is easier to read and also makes it easier to find
    the diff when BR changes.

* Parallel make
  - Parallel make seems okay for this package
    http://koji.fedoraproject.org/koji/taskinfo?taskID=185870

* Desktop vendor prefix
  - Usually we make desktop file have vendor prefix "fedora".
    (check the subsection "desktop-file-install usage" of
     http://fedoraproject.org/wiki/Packaging/Guidelines )
Comment 16 Frank Büttner 2007-10-07 07:06:40 EDT
"* Redundant BuildRequires
  - Remove redundant BuildRequires and reduce them.
    For example, PyQt4-devel Requires qt4-devel and sip-devel, so
    "BuildRequires: qt4-devel sip-devel" is not needed.
    (Please also check the rest BuildRequires!)"
qt4-devel is needed, because no other devel package contains qt4-devel >= 4.2
Qt <4.2 will not work with this package so it can't removed.

So here the next try:
SRPM:http://downloads.sourceforge.net/qsmartcard/qtiplot-0.9-6.fc8.src.rpm?use_mirror=osdn
SPEC: http://downloads.sourceforge.net/qsmartcard/qtiplot.spec?use_mirror=osdn
E: qtiplot library-without-ldconfig-postin /usr/lib/libfitRational1.so.1.0.0
E: qtiplot library-without-ldconfig-postun /usr/lib/libfitRational1.so.1.0.0
E: qtiplot library-without-ldconfig-postin /usr/lib/libfitRational0.so.1.0.0
E: qtiplot library-without-ldconfig-postun /usr/lib/libfitRational0.so.1.0.0
E: qtiplot no-ldconfig-symlink /usr/lib/libfitRational1.so.1.0.0
E: qtiplot no-ldconfig-symlink /usr/lib/libfitRational0.so.1.0.0
Are not errors in this case, because the libs are loaded by QLibrary
Comment 17 Mamoru TASAKA 2007-10-07 08:11:40 EDT
(In reply to comment #16)
> E: qtiplot library-without-ldconfig-postin /usr/lib/libfitRational1.so.1.0.0
> E: qtiplot library-without-ldconfig-postun /usr/lib/libfitRational1.so.1.0.0
> E: qtiplot library-without-ldconfig-postin /usr/lib/libfitRational0.so.1.0.0
> E: qtiplot library-without-ldconfig-postun /usr/lib/libfitRational0.so.1.0.0
> E: qtiplot no-ldconfig-symlink /usr/lib/libfitRational1.so.1.0.0
> E: qtiplot no-ldconfig-symlink /usr/lib/libfitRational0.so.1.0.0
> Are not errors in this case, because the libs are loaded by QLibrary

Well, then are these libraries loaded with the name 
"libfitRational1.so.1.0.0" or so? Is this surely okay?
Comment 18 Mamoru TASAKA 2007-10-07 08:16:27 EDT
Ah.. rather
* qtiplot-0.9/fitPlugins/fitRational0/fitRational0.pro says:
--------------------------------------------
target.path=/usr/lib$${libsuff}/qtiplot/plugins
--------------------------------------------
  Doesn't this mean that libfitRational0.so must be installed under
  %_libdir/%name/plugins ?
Comment 19 Frank Büttner 2007-10-07 08:46:28 EDT
(In reply to comment #17)
It will be work much easier, all files(excluded symlinks) will be load via 
QLibrary and checked for function signatures. For more read the Qt Doc and study
the example that comes with it. 
http://doc.trolltech.com/4.3/qlibrary.html
(In reply to comment #18)
No the files can be placed anywhere, you must only tell the application in the
config menu where to search for it.
But I is possible(but not explicit needed) to generate an extra lib dir for the
plug-ins.
Comment 20 Mamoru TASAKA 2007-10-07 08:54:03 EDT
(In reply to comment #19)
> (In reply to comment #18)
> No the files can be placed anywhere, you must only tell the application in the
> config menu where to search for it.
> But I is possible(but not explicit needed) to generate an extra lib dir for the
> plug-ins.

Then IMO it is better that this package has its own plugin directory
and all plugins for this package are moved into the directory.

Comment 21 Frank Büttner 2007-10-07 09:37:46 EDT
Ok, but this can I do only next weekend.
I will send it when it is ready.
Comment 22 Frank Büttner 2007-10-07 11:08:35 EDT
Now I have found some time to make this also ready:)
Here the one
SRPM:
http://downloads.sourceforge.net/qsmartcard/qtiplot-0.9-7.fc8.src.rpm?use_mirror=osdn
SPEC: http://downloads.sourceforge.net/qsmartcard/qtiplot.spec?use_mirror=osdn
Comment 23 Mamoru TASAKA 2007-10-08 02:10:27 EDT
Almost okay.

* Would you consider to set a icon for desktop file?
  Perhaps ./qtiplot_logo.png (size:128x128) can be used for the icon.

* Still -debuginfo rpm produces many rpmlint complaint about
  "wrong-script-end-of-line-encoding" and
  "spurious-executable-perm".
  ! Note: files under %_prefix/src/%name in -debuginfo rpm are
          just copied from builddir.
          For example, currently rpmlint complain about
--------------------------------------------------------------
qtiplot-debuginfo.i386: W: spurious-executable-perm
/usr/src/debug/qtiplot-0.9/qtiplot/src/FitDialog.h
--------------------------------------------------------------
          This is because the permission of
          "qtiplot/src/FitDialog.h" in source tarball is incorrect.
Comment 24 Mamoru TASAKA 2007-10-15 11:24:01 EDT
ping?
Comment 25 Frank Büttner 2007-10-15 12:22:59 EDT
pong:)
I can only work on it next weekend.
Comment 27 Mamoru TASAKA 2007-10-20 12:17:11 EDT
One thing need fixing.

- Desktop icon (qtiplot_logo.png) must be installed under %_datadir/pixmaps/.
  This works for me.

--------------------------------------------------------------------
     This package (qtiplot) is APPROVED by me
--------------------------------------------------------------------

Info:
For http://fedoraproject.org/wiki/PackageMaintainers/CVSAdminProcedure ,
F-8 branch will come soon
https://www.redhat.com/archives/fedora-devel-list/2007-October/msg01515.html
Comment 28 Frank Büttner 2007-10-20 13:24:20 EDT
fixed with:
install -m 0644 -p qtiplot_logo.png
$RPM_BUILD_ROOT/%{_datadir}/pixmaps/qtiplot_logo.png
%{_datadir}/pixmaps/*

New Package CVS Request
=======================
Package Name: qtiplot 
Short Data Analysis and Scientific Plotting
Owners: frankb
Branches: FC-6 F-7  F-8 EL-5
InitialCC: frankb
Cvsextras Commits: no
Comment 29 Kevin Fenzi 2007-10-21 12:58:55 EDT
cvs done.
Comment 30 Frank Büttner 2007-10-21 14:59:58 EDT
import done.
Build for devel and F8.
Comment 31 Mamoru TASAKA 2007-10-21 19:44:56 EDT
Okay. For this bug I will close for now.
Comment 33 Frank Büttner 2008-01-19 14:18:40 EST
It was released by me.
I don't know why it is not on the mirror serves.

Note You need to log in before you can comment on or make changes to this bug.